Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mortbay.jetty
Class Response

    java.lang.Object
      org.mortbay.jetty.Response

All Implemented Interfaces:
  HttpServletResponse, ServletResponse

    public class Response

extends Object
implements HttpServletResponse

Response.

Implements `HttpServletResponse` from the `javax.servlet` package.

Author:
  gregw

Field Summary
`static int` | `DISABLED`
`static int` | `NONE`
`static int` | `STREAM`
`static int` | `WRITER`

Fields inherited from interface javax.servlet.http.HttpServletResponse
`SC_ACCEPTED, SC_BAD_GATEWAY, SC_BAD_REQUEST, SC_CONFLICT, SC_CONTINUE, SC_CREATED, SC_EXPECTATION_FAILED, SC_FORBIDDEN, SC_FOUND, SC_GATEWAY_TIMEOUT, SC_GONE, SC_HTTP_VERSION_NOT_SUPPORTED, SC_INTERNAL_SERVER_ERROR, SC_LENGTH_REQUIRED, SC_METHOD_NOT_ALLOWED, SC_MOVED_PERMANENTLY, SC_MOVED_TEMPORARILY, SC_MULTIPLE_CHOICES, SC_NO_CONTENT, SC_NON_AUTHORITATIVE_INFORMATION, SC_NOT_ACCEPTABLE, SC_NOT_FOUND, SC_NOT_IMPLEMENTED, SC_NOT_MODIFIED, SC_OK, SC_PARTIAL_CONTENT, SC_PAYMENT_REQUIRED, SC_PRECONDITION_FAILED, SC_PROXY_AUTHENTICATION_REQUIRED, SC_REQUEST_ENTITY_TOO_LARGE, SC_REQUEST_TIMEOUT, SC_REQUEST_URI_TOO_LONG, SC_REQUESTED_RANGE_NOT_SATISFIABLE, SC_RESET_CONTENT, SC_SEE_OTHER, SC_SERVICE_UNAVAILABLE, SC_SWITCHING_PROTOCOLS, SC_TEMPORARY_REDIRECT, SC_UNAUTHORIZED, SC_UNSUPPORTED_MEDIA_TYPE, SC_USE_PROXY`

Constructor Summary
`Response(HttpConnection connection)`

Method Summary
`void` | `addCookie(Cookie cookie)` Adds the specified cookie to the response.
`void` | `addDateHeader(String name, long date)` Adds a response header with the given name and date-value.
`void` | `addHeader(String name, String value)` Adds a response header with the given name and value.
`void` | `addIntHeader(String name, int value)` Adds a response header with the given name and integer value.
`void` | `complete()`
`boolean` | `containsHeader(String name)` Returns a boolean indicating whether the named response header has already been set.
`String` | `encodeRedirectUrl(String url)`
`String` | `encodeRedirectURL(String url)` Encodes the specified URL for use in the `sendRedirect` method or, if encoding is not needed, returns the URL unchanged.
`String` | `encodeUrl(String url)`
`String` | `encodeURL(String url)` Encodes the specified URL by including the session ID in it, or, if encoding is not needed, returns the URL unchanged.
`void` | `flushBuffer()` Forces any content in the buffer to be written to the client.
`int` | `getBufferSize()` Returns the actual buffer size used for the response.
`String` | `getCharacterEncoding()` Returns the name of the character encoding (MIME charset) used for the body sent in this response.
`long` | `getContentCount()`
`String` | `getContentType()` Returns the content type used for the MIME body sent in this response.
`String` | `getHeader(String name)`
`Enumeration` | `getHeaders(String name)`
`HttpFields` | `getHttpFields()`
`Locale` | `getLocale()` Returns the locale specified for this response using the `ServletResponse.setLocale(java.util.Locale)` method.
`ServletOutputStream` | `getOutputStream()` Returns a `ServletOutputStream` suitable for writing binary data in the response.
`String` | `getReason()`
`int` | `getStatus()`
`PrintWriter` | `getWriter()` Returns a `PrintWriter` object that can send character text to the client.
`boolean` | `isCommitted()` Returns a boolean indicating if the response has been committed.
`boolean` | `isWriting()`
`protected void` | `recycle()`
`void` | `reset()` Clears any data that exists in the buffer as well as the status code and headers.
`void` | `resetBuffer()` Clears the content of the underlying buffer in the response without clearing headers or status code.
`void` | `sendError(int sc)` Sends an error response to the client using the specified status code and clearing the buffer.
`void` | `sendError(int code, String message)` Sends an error response to the client using the specified status.
`void` | `sendProcessing()`
`void` | `sendRedirect(String location)` Sends a temporary redirect response to the client using the specified redirect location URL.
`void` | `setBufferSize(int size)` Sets the preferred buffer size for the body of the response.
`void` | `setCharacterEncoding(String encoding)` Sets the character encoding (MIME charset) of the response being sent to the client, for example, to UTF-8.
`void` | `setContentLength(int len)` Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.
`void` | `setContentType(String contentType)` Sets the content type of the response being sent to the client, if the response has not been committed yet.
`void` | `setDateHeader(String name, long date)` Sets a response header with the given name and date-value.
`void` | `setHeader(String name, String value)` Sets a response header with the given name and value.
`void` | `setIntHeader(String name, int value)` Sets a response header with the given name and integer value.
`void` | `setLocale(Locale locale)` Sets the locale of the response, if the response has not been committed yet.
`void` | `setLongContentLength(long len)`
`void` | `setStatus(int sc)` Sets the status code for this response.
`void` | `setStatus(int sc, String sm)`
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### DISABLED

    public static final int DISABLED

See Also:
  Constant Field Values

### NONE

    public static final int NONE

See Also:
  Constant Field Values

### STREAM

    public static final int STREAM

See Also:
  Constant Field Values

### WRITER

    public static final int WRITER

See Also:
  Constant Field Values

Constructor Detail

### Response

    public Response(HttpConnection connection)

Method Detail

### recycle

    protected void recycle()

### addCookie

    public void addCookie(Cookie cookie)

  Description copied from interface: `HttpServletResponse`
  Adds the specified cookie to the response. This method can be called multiple times to set more than one cookie.

  Specified by:
    `addCookie` in interface `HttpServletResponse`
  Parameters:
    `cookie` - the Cookie to return to the client

### containsHeader

    public boolean containsHeader(String name)

  Description copied from interface: `HttpServletResponse`
  Returns a boolean indicating whether the named response header has already been set.

  Specified by:
    `containsHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the header name
  Returns:
    `true` if the named response header has already been set; `false` otherwise

### encodeURL

    public String encodeURL(String url)

  Description copied from interface: `HttpServletResponse`
  Encodes the specified URL by including the session ID in it, or, if encoding is not needed, returns the URL unchanged. The implementation of this method includes the logic to determine whether the session ID needs to be encoded in the URL. For example, if the browser supports cookies, or session tracking is turned off, URL encoding is unnecessary.

  For robust session tracking, all URLs emitted by a servlet should be run through this method. Otherwise, URL rewriting cannot be used with browsers which do not support cookies.

  Specified by:
    `encodeURL` in interface `HttpServletResponse`
  Parameters:
    `url` - the url to be encoded.
  Returns:
    the encoded URL if encoding is needed; the unchanged URL otherwise.

### encodeRedirectURL

    public String encodeRedirectURL(String url)

  Description copied from interface: `HttpServletResponse`
  Encodes the specified URL for use in the `sendRedirect` method or, if encoding is not needed, returns the URL unchanged. The implementation of this method includes the logic to determine whether the session ID needs to be encoded in the URL. Because the rules for making this determination can differ from those used to decide whether to encode a normal link, this method is separated from the `encodeURL` method.

  All URLs sent to the `HttpServletResponse.sendRedirect` method should be run through this method. Otherwise, URL rewriting cannot be used with browsers which do not support cookies.

  Specified by:
    `encodeRedirectURL` in interface `HttpServletResponse`
  Parameters:
    `url` - the url to be encoded.
  Returns:
    the encoded URL if encoding is needed; the unchanged URL otherwise.
  See Also:
    `HttpServletResponse.sendRedirect(java.lang.String)`, `HttpServletResponse.encodeUrl(java.lang.String)`

### encodeUrl

    public String encodeUrl(String url)

  Specified by:
    `encodeUrl` in interface `HttpServletResponse`
  Parameters:
    `url` - the url to be encoded.
  Returns:
    the encoded URL if encoding is needed; the unchanged URL otherwise.

### encodeRedirectUrl

    public String encodeRedirectUrl(String url)

  Specified by:
    `encodeRedirectUrl` in interface `HttpServletResponse`
  Parameters:
    `url` - the url to be encoded.
  Returns:
    the encoded URL if encoding is needed; the unchanged URL otherwise.

### sendError

    public void sendError(int code,
                          String message)
                   throws IOException

  Description copied from interface: `HttpServletResponse`
  Sends an error response to the client using the specified status. The server defaults to creating the response to look like an HTML-formatted server error page containing the specified message, setting the content type to "text/html", leaving cookies and other headers unmodified. If an error-page declaration has been made for the web application corresponding to the status code passed in, it will be served back in preference to the suggested msg parameter.

  If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.

  Specified by:
    `sendError` in interface `HttpServletResponse`
  Parameters:
    `code` - the error status code
    `message` - the descriptive message
  Throws:
    `IOException` - If an input or output exception occurs

### sendError

    public void sendError(int sc)
                   throws IOException

  Description copied from interface: `HttpServletResponse`
  Sends an error response to the client using the specified status code and clearing the buffer.

  If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.

  Specified by:
    `sendError` in interface `HttpServletResponse`
  Parameters:
    `sc` - the error status code
  Throws:
    `IOException` - If an input or output exception occurs

### sendProcessing

    public void sendProcessing()
                        throws IOException

  Throws:
    `IOException`

### sendRedirect

    public void sendRedirect(String location)
                      throws IOException

  Description copied from interface: `HttpServletResponse`
  Sends a temporary redirect response to the client using the specified redirect location URL. This method can accept relative URLs; the servlet container must convert the relative URL to an absolute URL before sending the response to the client. If the location is relative without a leading '/' the container interprets it as relative to the current request URI. If the location is relative with a leading '/' the container interprets it as relative to the servlet container root.

  If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.

  Specified by:
    `sendRedirect` in interface `HttpServletResponse`
  Parameters:
    `location` - the redirect location URL
  Throws:
    `IOException` - If an input or output exception occurs

### setDateHeader

    public void setDateHeader(String name,
                              long date)

  Description copied from interface: `HttpServletResponse`
  Sets a response header with the given name and date-value. The date is specified in terms of milliseconds since the epoch. If the header had already been set, the new value overwrites the previous one. The `containsHeader` method can be used to test for the presence of a header before setting its value.

  Specified by:
    `setDateHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header to set
    `date` - the assigned date value
  See Also:
    `HttpServletResponse.containsHeader(java.lang.String)`, `HttpServletResponse.addDateHeader(java.lang.String, long)`

### addDateHeader

    public void addDateHeader(String name,
                              long date)

  Description copied from interface: `HttpServletResponse`
  Adds a response header with the given name and date-value. The date is specified in terms of milliseconds since the epoch. This method allows response headers to have multiple values.

  Specified by:
    `addDateHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header to set
    `date` - the additional date value
  See Also:
    `HttpServletResponse.setDateHeader(java.lang.String, long)`

### setHeader

    public void setHeader(String name,
                          String value)

  Description copied from interface: `HttpServletResponse`
  Sets a response header with the given name and value. If the header had already been set, the new value overwrites the previous one. The `containsHeader` method can be used to test for the presence of a header before setting its value.

  Specified by:
    `setHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header
    `value` - the header value If it contains octet string, it should be encoded according to RFC 2047 (http://www.ietf.org/rfc/rfc2047.txt)
  See Also:
    `HttpServletResponse.containsHeader(java.lang.String)`, `HttpServletResponse.addHeader(java.lang.String, java.lang.String)`

### getHeader

    public String getHeader(String name)

### getHeaders

    public Enumeration getHeaders(String name)

### addHeader

    public void addHeader(String name,
                          String value)

  Description copied from interface: `HttpServletResponse`
  Adds a response header with the given name and value. This method allows response headers to have multiple values.

  Specified by:
    `addHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header
    `value` - the additional header value If it contains octet string, it should be encoded according to RFC 2047 (http://www.ietf.org/rfc/rfc2047.txt)
  See Also:
    `HttpServletResponse.setHeader(java.lang.String, java.lang.String)`

### setIntHeader

    public void setIntHeader(String name,
                             int value)

  Description copied from interface: `HttpServletResponse`
  Sets a response header with the given name and integer value. If the header had already been set, the new value overwrites the previous one. The `containsHeader` method can be used to test for the presence of a header before setting its value.

  Specified by:
    `setIntHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header
    `value` - the assigned integer value
  See Also:
    `HttpServletResponse.containsHeader(java.lang.String)`, `HttpServletResponse.addIntHeader(java.lang.String, int)`

### addIntHeader

    public void addIntHeader(String name,
                             int value)

  Description copied from interface: `HttpServletResponse`
  Adds a response header with the given name and integer value. This method allows response headers to have multiple values.

  Specified by:
    `addIntHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header
    `value` - the assigned integer value
  See Also:
    `HttpServletResponse.setIntHeader(java.lang.String, int)`

### setStatus

    public void setStatus(int sc)

  Description copied from interface: `HttpServletResponse`
  Sets the status code for this response. This method is used to set the return status code when there is no error (for example, for the status codes SC_OK or SC_MOVED_TEMPORARILY). If there is an error, and the caller wishes to invoke an error-page defined in the web application, the `sendError` method should be used instead.

  The container clears the buffer and sets the Location header, preserving cookies and other headers.

  Specified by:
    `setStatus` in interface `HttpServletResponse`
  Parameters:
    `sc` - the status code
  See Also:
    `HttpServletResponse.sendError(int, java.lang.String)`

### setStatus

    public void setStatus(int sc,
                          String sm)

  Specified by:
    `setStatus` in interface `HttpServletResponse`
  Parameters:
    `sc` - the status code
    `sm` - the status message

### getCharacterEncoding

    public String getCharacterEncoding()

  Description copied from interface: `ServletResponse`
  Returns the name of the character encoding (MIME charset) used for the body sent in this response. The character encoding may have been specified explicitly using the `ServletResponse.setCharacterEncoding(java.lang.String)` or `ServletResponse.setContentType(java.lang.String)` methods, or implicitly using the `ServletResponse.setLocale(java.util.Locale)` method. Explicit specifications take precedence over implicit specifications. Calls made to these methods after `getWriter` has been called or after the response has been committed have no effect on the character encoding. If no character encoding has been specified, `ISO-8859-1` is returned.

  See RFC 2047 (http://www.ietf.org/rfc/rfc2047.txt) for more information about character encoding and MIME.

  Specified by:
    `getCharacterEncoding` in interface `ServletResponse`
  Returns:
    a `String` specifying the name of the character encoding, for example, `UTF-8`

### getContentType

    public String getContentType()

  Description copied from interface: `ServletResponse`
  Returns the content type used for the MIME body sent in this response. The content type proper must have been specified using `ServletResponse.setContentType(java.lang.String)` before the response is committed. If no content type has been specified, this method returns null. If a content type has been specified, and a character encoding has been explicitly or implicitly specified as described in `ServletResponse.getCharacterEncoding()` or `ServletResponse.getWriter()` has been called, the charset parameter is included in the string returned. If no character encoding has been specified, the charset parameter is omitted.

  Specified by:
    `getContentType` in interface `ServletResponse`
  Returns:
    a `String` specifying the content type, for example, `text/html; charset=UTF-8`, or null

### getOutputStream

    public ServletOutputStream getOutputStream()
                                        throws IOException

  Description copied from interface: `ServletResponse`
  Returns a `ServletOutputStream` suitable for writing binary data in the response. The servlet container does not encode the binary data.

  Calling flush() on the ServletOutputStream commits the response. Either this method or `ServletResponse.getWriter()` may be called to write the body, not both.

  Specified by:
    `getOutputStream` in interface `ServletResponse`
  Returns:
    a `ServletOutputStream` for writing binary data
  Throws:
    `IOException` - if an input or output exception occurred
  See Also:
    `ServletResponse.getWriter()`

### isWriting

    public boolean isWriting()

### getWriter

    public PrintWriter getWriter()
                          throws IOException

  Description copied from interface: `ServletResponse`
  Returns a `PrintWriter` object that can send character text to the client. The `PrintWriter` uses the character encoding returned by `ServletResponse.getCharacterEncoding()`. If the response's character encoding has not been specified as described in `getCharacterEncoding` (i.e., the method just returns the default value `ISO-8859-1`), `getWriter` updates it to `ISO-8859-1`.

  Calling flush() on the `PrintWriter` commits the response.

  Either this method or `ServletResponse.getOutputStream()` may be called to write the body, not both.

  Specified by:
    `getWriter` in interface `ServletResponse`
  Returns:
    a `PrintWriter` object that can return character data to the client
  Throws:
    `IOException` - if an input or output exception occurred
  See Also:
    `ServletResponse.getOutputStream()`, `ServletResponse.setCharacterEncoding(java.lang.String)`

### setCharacterEncoding

    public void setCharacterEncoding(String encoding)

  Description copied from interface: `ServletResponse`
  Sets the character encoding (MIME charset) of the response being sent to the client, for example, to UTF-8. If the character encoding has already been set by `ServletResponse.setContentType(java.lang.String)` or `ServletResponse.setLocale(java.util.Locale)`, this method overrides it. Calling `ServletResponse.setContentType(java.lang.String)` with the `String` of `text/html` and calling this method with the `String` of `UTF-8` is equivalent with calling `setContentType` with the `String` of `text/html; charset=UTF-8`.

  This method can be called repeatedly to change the character encoding. This method has no effect if it is called after `getWriter` has been called or after the response has been committed.

  Containers must communicate the character encoding used for the servlet response's writer to the client if the protocol provides a way for doing so. In the case of HTTP, the character encoding is communicated as part of the `Content-Type` header for text media types. Note that the character encoding cannot be communicated via HTTP headers if the servlet does not specify a content type; however, it is still used to encode text written via the servlet response's writer.

  Specified by:
    `setCharacterEncoding` in interface `ServletResponse`
  Parameters:
    `encoding` - a String specifying only the character set defined by IANA Character Sets (http://www.iana.org/assignments/character-sets)
  See Also:
    `#setLocale`

### setContentLength

    public void setContentLength(int len)

  Description copied from interface: `ServletResponse`
  Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.

  Specified by:
    `setContentLength` in interface `ServletResponse`
  Parameters:
    `len` - an integer specifying the length of the content being returned to the client; sets the Content-Length header

### setLongContentLength

    public void setLongContentLength(long len)

### setContentType

    public void setContentType(String contentType)

  Description copied from interface: `ServletResponse`
  Sets the content type of the response being sent to the client, if the response has not been committed yet. The given content type may include a character encoding specification, for example, `text/html;charset=UTF-8`. The response's character encoding is only set from the given content type if this method is called before `getWriter` is called.

  This method may be called repeatedly to change content type and character encoding. This method has no effect if called after the response has been committed. It does not set the response's character encoding if it is called after `getWriter` has been called or after the response has been committed.

  Containers must communicate the content type and the character encoding used for the servlet response's writer to the client if the protocol provides a way for doing so. In the case of HTTP, the `Content-Type` header is used.

  Specified by:
    `setContentType` in interface `ServletResponse`
  Parameters:
    `contentType` - a `String` specifying the MIME type of the content
  See Also:
    `ServletResponse.setLocale(java.util.Locale)`, `ServletResponse.setCharacterEncoding(java.lang.String)`, `ServletResponse.getOutputStream()`, `ServletResponse.getWriter()`

### setBufferSize

    public void setBufferSize(int size)

  Description copied from interface: `ServletResponse`
  Sets the preferred buffer size for the body of the response. The servlet container will use a buffer at least as large as the size requested. The actual buffer size used can be found using `getBufferSize`.

  A larger buffer allows more content to be written before anything is actually sent, thus providing the servlet with more time to set appropriate status codes and headers. A smaller buffer decreases server memory load and allows the client to start receiving data more quickly.

  This method must be called before any response body content is written; if content has been written or the response object has been committed, this method throws an `IllegalStateException`.

  Specified by:
    `setBufferSize` in interface `ServletResponse`
  Parameters:
    `size` - the preferred buffer size
  See Also:
    `ServletResponse.getBufferSize()`, `ServletResponse.flushBuffer()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

### getBufferSize

    public int getBufferSize()

  Description copied from interface: `ServletResponse`
  Returns the actual buffer size used for the response. If no buffering is used, this method returns 0.

  Specified by:
    `getBufferSize` in interface `ServletResponse`
  Returns:
    the actual buffer size used
  See Also:
    `ServletResponse.setBufferSize(int)`, `ServletResponse.flushBuffer()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

### flushBuffer

    public void flushBuffer()
                     throws IOException

  Description copied from interface: `ServletResponse`
  Forces any content in the buffer to be written to the client. A call to this method automatically commits the response, meaning the status code and headers will be written.

  Specified by:
    `flushBuffer` in interface `ServletResponse`
  Throws:
    `IOException`
  See Also:
    `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

### reset

    public void reset()

  Description copied from interface: `ServletResponse`
  Clears any data that exists in the buffer as well as the status code and headers. If the response has been committed, this method throws an `IllegalStateException`.

  Specified by:
    `reset` in interface `ServletResponse`
  See Also:
    `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.flushBuffer()`, `ServletResponse.isCommitted()`

### resetBuffer

    public void resetBuffer()

  Description copied from interface: `ServletResponse`
  Clears the content of the underlying buffer in the response without clearing headers or status code. If the response has been committed, this method throws an `IllegalStateException`.

  Specified by:
    `resetBuffer` in interface `ServletResponse`
  See Also:
    `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

### isCommitted

    public boolean isCommitted()

  Description copied from interface: `ServletResponse`
  Returns a boolean indicating if the response has been committed. A committed response has already had its status code and headers written.

  Specified by:
    `isCommitted` in interface `ServletResponse`
  Returns:
    a boolean indicating if the response has been committed
  See Also:
    `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.flushBuffer()`, `ServletResponse.reset()`

### setLocale

    public void setLocale(Locale locale)

  Description copied from interface: `ServletResponse`
  Sets the locale of the response, if the response has not been committed yet. It also sets the response's character encoding appropriately for the locale, if the character encoding has not been explicitly set using `ServletResponse.setContentType(java.lang.String)` or `ServletResponse.setCharacterEncoding(java.lang.String)`, `getWriter` hasn't been called yet, and the response hasn't been committed yet. If the deployment descriptor contains a `locale-encoding-mapping-list` element, and that element provides a mapping for the given locale, that mapping is used. Otherwise, the mapping from locale to character encoding is container dependent.

  This method may be called repeatedly to change locale and character encoding. The method has no effect if called after the response has been committed. It does not set the response's character encoding if it is called after `ServletResponse.setContentType(java.lang.String)` has been called with a charset specification, after `ServletResponse.setCharacterEncoding(java.lang.String)` has been called, after `getWriter` has been called, or after the response has been committed.

  Containers must communicate the locale and the character encoding used for the servlet response's writer to the client if the protocol provides a way for doing so. In the case of HTTP, the locale is communicated via the `Content-Language` header, the character encoding as part of the `Content-Type` header for text media types. Note that the character encoding cannot be communicated via HTTP headers if the servlet does not specify a content type; however, it is still used to encode text written via the servlet response's writer.

  Specified by:
    `setLocale` in interface `ServletResponse`
  Parameters:
    `locale` - the locale of the response
  See Also:
    `ServletResponse.getLocale()`, `ServletResponse.setContentType(java.lang.String)`, `ServletResponse.setCharacterEncoding(java.lang.String)`

### getLocale

    public Locale getLocale()

  Description copied from interface: `ServletResponse`
  Returns the locale specified for this response using the `ServletResponse.setLocale(java.util.Locale)` method. Calls made to `setLocale` after the response is committed have no effect. If no locale has been specified, the container's default locale is returned.

  Specified by:
    `getLocale` in interface `ServletResponse`
  See Also:
    `ServletResponse.setLocale(java.util.Locale)`

### getStatus

    public int getStatus()

  Returns:
    The HTTP status code that has been set for this request. This will be `200`(`HttpServletResponse.SC_OK`), unless explicitly set through one of the `setStatus` methods.``

### getReason

    public String getReason()

  Returns:
    The reason associated with the current `status`. This will be `null`, unless one of the `setStatus` methods have been called.

### complete

    public void complete()
                  throws IOException

  Throws:
    `IOException`

### getContentCount

    public long getContentCount()

  Returns:
    the number of bytes actually written in response body

### getHttpFields

    public HttpFields getHttpFields()

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2007 Mort Bay Consulting. All Rights Reserved.